# Class OperationInfo

java.lang.Object
org.apache.tomcat.util.modeler.FeatureInfo
org.apache.tomcat.util.modeler.OperationInfo

All Implemented Interfaces:
  `Serializable`

public class OperationInfo extends FeatureInfo

Internal configuration information for an `Operation` descriptor.

See Also:
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`protected String`
`impact`
Impact of the operation.
`protected ParameterInfo[]`
`parameters`
Array of parameters.
`protected final ReadWriteLock`
`parametersLock`
Lock for parameter access.
`protected String`
`role`
Role of the operation.

### Fields inherited from class FeatureInfo

`description, info, name, type`

## Constructor Summary

Constructors
Constructor
Description
`OperationInfo()`
Standard zero-arguments constructor.

## Method Summary

Modifier and Type
Method
Description
`void`
`addParameter(ParameterInfo parameter)`
Add a new parameter to the set of arguments for this operation.
`String`
`getImpact()`
Returns the "impact" of this operation, which should be a (case-insensitive) string value "ACTION", "ACTION_INFO", "INFO", or "UNKNOWN".
`protected MBeanParameterInfo[]`
`getMBeanParameterInfo()`
Creates an array of MBeanParameterInfo from the operation parameters.
`String`
`getReturnType()`
Returns the fully qualified Java class name of the return type for this operation.
`String`
`getRole()`
Returns the role of this operation ("getter", "setter", "operation", or "constructor").
`ParameterInfo[]`
`getSignature()`
Returns the array of parameters for this operation.
`void`
`setImpact(String impact)`
Sets the impact of this operation.
`void`
`setReturnType(String returnType)`
Sets the return type of this operation.
`void`
`setRole(String role)`
Sets the role of this operation.

### Methods inherited from class FeatureInfo

`getDescription, getName, getType, setDescription, setName, setType`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### impact

protected String impact
Impact of the operation.

### role

protected String role
Role of the operation.

### parametersLock

protected final ReadWriteLock parametersLock
Lock for parameter access.

### parameters

protected ParameterInfo[] parameters
Array of parameters.

## Constructor Details

### OperationInfo

public OperationInfo()
Standard zero-arguments constructor.

## Method Details

### getImpact

public String getImpact()
Returns the "impact" of this operation, which should be a (case-insensitive) string value "ACTION", "ACTION_INFO", "INFO", or "UNKNOWN".

Returns:
  The impact of this operation

### setImpact

public void setImpact(String impact)
Sets the impact of this operation.

Parameters:
  `impact` - The impact value

### getRole

public String getRole()
Returns the role of this operation ("getter", "setter", "operation", or "constructor").

Returns:
  The role of this operation

### setRole

public void setRole(String role)
Sets the role of this operation.

Parameters:
  `role` - The role value

### getReturnType

public String getReturnType()
Returns the fully qualified Java class name of the return type for this operation.

Returns:
  The return type

### setReturnType

public void setReturnType(String returnType)
Sets the return type of this operation.

Parameters:
  `returnType` - The return type

### getSignature

public ParameterInfo[] getSignature()
Returns the array of parameters for this operation.

Returns:
  The parameter array

### addParameter

public void addParameter(ParameterInfo parameter)
Add a new parameter to the set of arguments for this operation.

Parameters:
  `parameter` - The new parameter descriptor

### getMBeanParameterInfo

protected MBeanParameterInfo[] getMBeanParameterInfo()
Creates an array of MBeanParameterInfo from the operation parameters.

Returns:
  The MBean parameter info array